<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <script>

        var id = null;
        const multipleQueries = function(){
            var query = `{sayHi(name:"Tom") hello }`;
            fetch("http://127.0.0.1:3000/graphql", {
                method: "POST",
                headers:{
                    "Content-Type":"application/json",
                    "Accept":"application/json"
                },
                body: JSON.stringify({
                    query
                })
            }).then(r=>r.json())
            .then(data=>{
                console.log(data);
            })
        }

        const getMessage = function(){
            var query = `{getMessage(id: "${id}"){ author content }}`
            fetch("http://127.0.0.1:3000/graphql",{
                method: 'POST',
                headers:{
                    "Content-Type":"application/json",
                    "Accept":"application/json"
                },
                body: JSON.stringify({
                    query
                })
            })
            .then(r=>r.json())
            .then(data=>{
                console.log(`data returned: ${data}`); 
                id = data.createMessage.id; 
                console.log(id);
            });
        }

        const CreateMessage = async function(){

            var author = "andy";
            var content = "this is testing createMessage"
            var query = `mutation CreateMessage($input: MessageInput){
                createMessage(input: $input){
                    id
                }
            }`
            
            try{

                const response = await fetch("http://127.0.0.1:3000/graphql",{
                    method: 'POST',
                    headers:{
                        "Content-Type":"application/json",
                        "Accept":"application/json"
                    },
                    body: JSON.stringify({
                        query,
                        variables:{
                            input:{
                                author,
                                content
                            }
                        }
                    })
                })

                const data = await response.json(); 
                console.log(`data returned: `, data); 
                id = data.data.createMessage.id; 
                console.log(id);

            }catch(e){
                console.error(e);
            }
        }

        var init = async function(){
            await CreateMessage();
            getMessage();
            multipleQueries();
        }
        init();
    </script>
</head>
<body>
    
</body>
</html>